/*
 * segatex SELinux tool.
 *
 * Copyright (C) 2007-2014 Shintaro Fujiwara 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * */

#include <Q3TextStream>
#include <qmessagebox.h>
//########by me#######
#include <selinux/get_context_list.h>
#include <sepol/sepol.h>
#include <unistd.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fstream>
//#########end by me #######
#include <iostream>
using namespace std;


#include "segatex_getorderedcontextlist.h"
#include "segatex_getorderedcontextlist_process.h"


SegatexGetorderedcontextlistProcess::SegatexGetorderedcontextlistProcess(QWidget *parent, const char *name): QDialog(parent, name)
{
	textEdit1 = new Q3TextEdit(this);
	textEdit1->setPaletteBackgroundColor(QColor(250,180,200));
	closeButton = new QPushButton(tr("close"), this);
	//closing process button
	connect(closeButton, SIGNAL(clicked()), this, SLOT(close()));
	closeButton->setDefault(true);
	mainLayout = new Q3VBoxLayout(this);
	mainLayout->setMargin(11);
	mainLayout->addWidget(textEdit1);
	mainLayout->addWidget(closeButton);
	resize(600,300);

	// do nothing
}

/* returns selinux user and level from linuxuser*/
int SegatexGetorderedcontextlistProcess::segatex_getorderedcontextlist_base_process(QString seuser_string)
{
		const char *seuser;
		seuser = seuser_string;
		seuser_str = seuser;
		security_context_t fromcon;
		security_context_t *list;
		fromcon = NULL;
		list = NULL;
	/* Get an ordered list of authorized security contexts for a user session
	 *    for 'user' spawned by 'fromcon' and set *conary to refer to the 
	 *       NULL-terminated array of contexts.  Every entry in the list will
	 *          be authorized by the policy, but the ordering is subject to user
	 *             customizable preferences.  Returns number of entries in *conary.
	 *                If 'fromcon' is NULL, defaults to current context.
	 *                   Caller must free via freeconary. */
	/*
		extern int get_ordered_context_list(const char *user,
						    security_context_t fromcon,
						    security_context_t ** list);
	*/
	/*
		list_str="";
		if((get_ordered_context_list(seuser,fromcon,&list)) < 0){
			QMessageBox::information(this,tr("segatex alert"),tr("getorderedcontextlist got an error !"));
			return 0;
		}
		while(*list){
			list_str = list_str + (QString)**&list + "\n";	
			//size_t list_size = sizeof(*list);
			*list ++;
		}

		QMessageBox::information(this,tr(seuser_string +"'s getorderedcontextlist"),tr(list_str));
		freecon(*list);
	*/
		#define PWD_BUF 8600
		const char* segatex_getorderedcontextlist_file="/usr/share/segatex/segatex_getorderedcontextlist";
		ofstream os;
		os.open(segatex_getorderedcontextlist_file);
		if(os){
			FILE *read_fp;
			#define SIZE_TMP 8600
			char buffer[SIZE_TMP];
			int chars_read;
			memset(buffer, '\0', sizeof(buffer));
			const char *command_str_pre;
			QString command_str, command_str_pre_qstring;
			command_str_pre = "/usr/share/segatex/utils/getorderedcontextlist ";
			command_str_pre_qstring = (QString)command_str_pre;
			command_str = command_str_pre_qstring + seuser_string;
			read_fp = popen(command_str, "r");
			if(read_fp != NULL){
				chars_read = fread(buffer, sizeof(char), SIZE_TMP, read_fp);
				while(chars_read>0){
					buffer[chars_read -1] = '\0';
					//os << "Reading:-" << endl;
					os << buffer;
					chars_read= fread(buffer, sizeof(char), SIZE_TMP, read_fp);
				}
				pclose(read_fp);
			}
		}
		os.close();
		readFromOutputFile();
	//}
}
//this slot should be called from above slot
void SegatexGetorderedcontextlistProcess::readFromOutputFile()
{
	/////////////////////////////////////////////////////////////
	path = "/usr/share/segatex";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	dir.setPath(path);
	dir_name = dir.absPath();
	/////////////////////////////////////////////////////////////
	dir.setFilter( QDir::Files );
        dir.setSorting( QDir::Name );
	outputfile_str = "segatex_getorderedcontextlist";
	files = dir.entryList(outputfile_str);
	/////////////////////////////////////////////////////////////
	it_d = files.begin();
	int order_x;
	order_x = 1;
	//first clear it all, unless double the file.
	textEdit1->clear();
		while(it_d != files.end()){
			name = *it_d;
			file_interface_name = dir_name + forward_slash + name;
			//cout << "file_interface_name:" << file_interface_name << endl;
			QFile file( file_interface_name );
			if ( file.open( QIODevice::ReadOnly ) ) {
				Q3TextStream stream( &file );
				////////////////////////////////////////////
				while ( !stream.atEnd() ) {
					line_analized = stream.readLine(); // line of text excluding '\n'
					textEdit1->append(line_analized);
				}
				file.close();
				order_x++;
				++it_d;
			}else{
				//do nothing
			}
		}
	textEdit1->setCursorPosition(0,0);
}
